config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root 'tickets#index'

  resources :tickets, only: %i[index show]

  namespace :api do
    namespace :v1 do
      resources :tickets, only: :create
    end
  end
end

app/models/address.rb
class Address < ApplicationRecord
  belongs_to :excavator, inverse_of: :address

  validates :address, presence: true
  validates :city,    presence: true
  validates :state,   presence: true
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/excavator.rb
class Excavator < ApplicationRecord
  belongs_to :ticket, inverse_of: :excavator

  has_one :address, inverse_of: :excavator, dependent: :destroy

  validates :company_name, presence: true
  validates :ticket,       presence: true

  accepts_nested_attributes_for :address
end

app/models/ticket.rb
class Ticket < ApplicationRecord
  has_one :excavator, inverse_of: :ticket, dependent: :destroy
  NORMAL = 'Normal'.freeze
  URGENT = 'Urgent'.freeze

  enum request_type: {
    normal: NORMAL,
    urgent: URGENT
  }

  validates :request_number,  presence: true
  validates :sequence_number, presence: true
  validates :request_type,    presence: true

  accepts_nested_attributes_for :excavator
end

app/controllers/api/application_controller.rb
module Api
  class ApplicationController < ActionController::API
  end
end

app/controllers/api/v1/tickets_controller.rb
module Api
  module V1
    class TicketsController < Api::ApplicationController
      def create
        @resource = ::Tickets::Factory.call(params: params)

        if @resource.errors.blank?
          render :show
        else
          render :errors
        end
      end
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  rescue_from ActiveRecord::RecordNotFound, with: :resource_not_found

  def resource_not_found
    head :not_found
  end
end

app/controllers/tickets_controller.rb
class TicketsController < ApplicationController
  PER_PAGE = 15

  decorates_assigned :ticket

  def index
    @collection = Ticket.all
                        .page(params[:page])
                        .per(PER_PAGE)
                        .decorate
  end

  def show
    @ticket = Ticket.find(params[:id])
  end
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Test811</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  <%= javascript_include_tag "https://maps.googleapis.com/maps/api/js" %>
</head>

<body>
<%= yield %>
</body>
</html>

app/views/tickets/_ticket.html.erb
<tr>
  <td><%= link_to ticket.request_number, ticket_url(ticket) %></td>
  <td><%= ticket.sequence_number %></td>
  <td><%= ticket.primary_service_area %></td>
  <td><%= ticket.response_due_time %></td>
</tr>

app/views/tickets/index.html.erb
<table class='responsive'>
  <caption></caption>
  <thead>
    <tr>
      <th><%= Ticket.human_attribute_name(:request_number) %></th>
      <th><%= Ticket.human_attribute_name(:sequence_number) %></th>
      <th><%= Ticket.human_attribute_name(:primary_service_area) %></th>
      <th><%= Ticket.human_attribute_name(:response_due_time) %></th>
    </tr>
  </thead>
  <tbody>
    <%= render partial: 'ticket', collection: @collection, as: :ticket %>
  </tbody>
  <%= paginate @collection %>
</table>
<p class='pagination-info'>
  <%= page_entries_info @collection %>
</p>

app/views/tickets/show.html.erb
<div class="container">
  <h2>
    Ticket #<%= ticket.id %>
  </h2>
  <hr/>
  <div class="row field">
    <div class="col-sm-2 control-label">
      <label>
        <%= Ticket.human_attribute_name(:request_number) %>
      </label>
    </div>
    <div class="col-sm-10">
      <p>
        <%= ticket.request_number %>
      </p>
    </div>
  </div>
  <div class="row field">
    <div class="col-sm-2">
      <label>
        <%= Ticket.human_attribute_name(:sequence_number) %>
      </label>
    </div>
    <div class="col-sm-10">
      <p>
        <%= ticket.sequence_number %>
      </p>
    </div>
  </div>
  <% if ticket.request_type %>
    <div class="row field">
      <div class="col-sm-2">
        <label>
          <%= Ticket.human_attribute_name(:request_type) %>
        </label>
      </div>
      <div class="col-sm-10">
        <p>
          <%= ticket.request_type.capitalize %>
        </p>
      </div>
    </div>
  <% end %>
  <% if ticket.service_areas %>
    <div class="row field">
      <div class="col-sm-2">
        <label>
          <%= Ticket.human_attribute_name(:service_areas) %>
        </label>
      </div>
      <div class="col-sm-10">
        <p>
          <%= ticket.service_areas %>
        </p>
      </div>
    </div>
  <% end %>
  <% if ticket.response_due_time %>
    <div class="row field">
      <div class="col-sm-2">
        <label>
          <%= Ticket.human_attribute_name(:response_due_time) %>
        </label>
      </div>
      <div class="col-sm-10">
        <p>
          <%= ticket.due_time %>
        </p>
      </div>
    </div>
  <% end %>
  <% if ticket.polygon %>
    <div class="row field">
      <div class="col-sm-2">
        <label>
          <%= Ticket.human_attribute_name(:polygon) %>
        </label>
      </div>
      <div class="col-sm-10">
        <p>
          <%= ticket.polygon_coordinates %>
        </p>
      </div>
    </div>
  <% end %>
  <% if ticket.excavator %>
    <hr/>
    <h3>
      Excavator #<%= ticket.excavator_id %>
    </h3>
    <hr/>
    <div class="row field">
      <div class="col-sm-2">
        <label>
          <%= Excavator.human_attribute_name(:company_name) %>
        </label>
      </div>
      <div class="col-sm-10">
        <p>
          <%= ticket.excavator_company_name %>
        </p>
      </div>
    </div>
    <div class="row field">
      <div class="col-sm-2">
        <label>
          <%= Excavator.human_attribute_name(:manned) %>
        </label>
      </div>
      <div class="col-sm-10">
        <p>
          <%= ticket.excavator_manned_text %>
        </p>
      </div>
    </div>
    <div class="row field">
      <div class="col-sm-2">
        <label>
          <%= Address.human_attribute_name(:address_line) %>
        </label>
      </div>
      <div class="col-sm-10">
        <p>
          <%= ticket.full_address %>
        </p>
      </div>
    </div>
  <% end %>
  <% if ticket.polygon %>
    <hr/>
    <h3>
      <%= 'Area' %>
    </h3>
    <hr/>
    <div id="map" style="width: 100%; height: 800px" data-coordinates="<%= ticket.serialized_coordinates%>"></div>
  <% end %>
</div>